// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UDataAsset.h"
#include "ISCW_FBlackboardEntry.h"
#include <memory>
#include <vector>

using std::shared_ptr;
using std::vector;

namespace Sourcify
{	
	class ISCW_UBlackboardData : public virtual ISCW_UDataAsset
	{
	public:
		virtual ~ISCW_UBlackboardData() = default;
		
		virtual shared_ptr<ISCW_UBlackboardData> ToUBlackboardDataPtr() = 0;
		virtual shared_ptr<const ISCW_UBlackboardData> ToUBlackboardDataPtr() const = 0;

		virtual vector<ISCW_FBlackboardEntryPtr> GetKeys() const = 0;
	};

	using ISCW_UBlackboardDataConstPtr = shared_ptr<const ISCW_UBlackboardData>;
	using ISCW_UBlackboardDataPtr = shared_ptr<ISCW_UBlackboardData>;
} // namespace Sourcify